/**
 * Expression.java
 *
 * File generated from the XValidator4::Expression uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

// End of user code
import junit.framework.Assert;
import junit.framework.AssertionFailedError;
import net.ihe.gazelle.xvalidation.core.exception.GazelleXValidationException;
import net.ihe.gazelle.xvalidation.core.report.Notification;
import org.w3c.dom.Node;

import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import java.util.ArrayList;
import java.util.Map;

/**
 * Description of the class Expression.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Expression", propOrder = { "expression" })
@XmlRootElement(name = "Expression")
@Entity
@DiscriminatorValue("expression")
public class Expression extends AbstractExpression implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	@XmlElementRefs({ @XmlElementRef(name = "Not", type = Not.class),
			@XmlElementRef(name = "InValueSet", type = InValueSet.class),
			@XmlElementRef(name = "Present", type = Present.class),
			@XmlElementRef(name = "LogicalOperation", type = LogicalOperation.class),
			@XmlElementRef(name = "BasicOperation", type = BasicOperation.class),
            @XmlElementRef(name = "MathComparison", type = MathComparison.class),
			@XmlElementRef(name = "ForEach", type = ForEach.class),
			@XmlElementRef(name = "True", type = True.class), @XmlElementRef(name = "DateComparison", type = DateComparison.class) })
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "expression_id")
	private AbstractExpression expression;

	public Expression() {
		super();
	}

	public Expression(Expression exp) {
		super();
		if (exp != null && exp.getExpression() != null) {
			this.expression = exp.getExpression().createCopy();
		}
	}

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	/**
	 * 
	 * @return
	 */
	public AbstractExpression getExpression() {
		return expression;
	}

	public void setExpression(AbstractExpression expression) {
		this.expression = expression;
	}

	@Override
	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "Expression", this);
		}
		return xmlNodePresentation;
	}

	@Override
	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	@Override
	public Notification evaluate(Map<String, Node> documents, ValidatorConfiguration configuration, Level level) {
		if (expression != null) {
			return getExpression().evaluate(documents, configuration, level);
		} else {
			return abort("No Expression to evaluate.", null, "No Expression to evaluate.");
		}
	}

	@Override
	public String getEditLink() {
		return "/xvalidation/expressions/expression.xhtml";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = (prime * result) + ((expression == null) ? 0 : expression.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!super.equals(obj)) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		Expression other = (Expression) obj;
		if (expression == null) {
			if (other.expression != null) {
				return false;
			}
		} else if (!expression.equals(other.expression)) {
			return false;
		}
		return true;
	}

	@Override
	public void testCorrectness() throws AssertionFailedError {
		Assert.assertNotNull("[Expression #" + getFakeId() + "] No expression defined", expression);
		expression.testCorrectness();
	}

	public ArrayList<String> appliesTo() throws AssertionFailedError {
		if (expression != null) {
			return expression.appliesTo();
		} else {
			return null;
		}
	}

	public AbstractExpression createCopy() {
		if (this.expression != null) {
			return this.expression.createCopy();
		} else {
			return null;
		}
	}

}